#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "pilha.h"
using namespace std;

void inicializa(PILHA* p){
   p->topo = -1;
}

void empilha(PILHA* p, void* chave){
   assert(!cheia(p));
   p->A[++p->topo] = chave;
}

void* desempilha(PILHA* p){
   assert(!vazia(p));
   void* chave = p->A[p->topo--];
   return chave;
}

bool vazia(PILHA* p){
   return p->topo == -1;
}

bool cheia(PILHA* p){
   return p->topo == MAX_PILHA - 1;
}

void* topo(PILHA* p){
   return p->A[p->topo];
}

/*
int main() {
   PILHA pilha;
   inicializa(&pilha);
   string s1 = "str 1";
   string s2 = "str 2";
   string s3 = "str 3";
   string s4 = "str 4";
   string s5 = "str 5";

   // só pode empilhar ponteiros
   empilha(&pilha, &s1); // empilha o endereço de (ponteiro para) s1
   empilha(&pilha, &s2);
   empilha(&pilha, &s3);
   empilha(&pilha, &s4);
   empilha(&pilha, &s5);

   while(!vazia(&pilha)) {
      // na hora de desenpilhar, tem que fazer type casting
      // para o tipo específico do ponteiro, pois a função
      // desempilha devolve um ponteiro "genérico" (void*)
      string* ponteiro_para_string = (string*) desempilha(&pilha);

      string conteudo_da_string = *ponteiro_para_string;
      cout << conteudo_da_string << endl;
   }
}
*/
